@string{CAV = "International Conference on Computer Aided Verification (CAV)"}
@string{TACAS = "International Conference on Tools and Algorithms for Construction and Analysis of Systems (TACAS)"}
@string{PLDI = "Conference on Programming Language Design and Implementation (PLDI)"}
@string{APLAS = "Asian Symposium on Programming Languages and Systems (APLAS)"}
@string{ATVA = " International Symposium on Automated Technology for Verification and Analysis (ATVA)"}
@string{CADE = "International Conference on Automated Deduction (CADE)"}
@string{FSTTCS = "International Conference on Foundations of Software Technology and Theoretical Computer Science (FSTTCS)"}
@string{POPL = "Symposium on Principles of Programming Languages (POPL)"}

@inproceedings{Loc:CAV:2014,
 author = {Le, Quang Loc and Gherghina, Cristian and Qin, Shengchao and Chin, Wei-Ngan},
 title = {Shape Analysis via Second-Order Bi-Abduction},
 booktitle = {Proceedings of the 16th International Conference on Computer Aided Verification - Volume 8559},
 year = {2014},
 isbn = {978-3-319-08866-2},
 pages = {52--68},
 numpages = {17},
 url = {http://dx.doi.org/10.1007/978-3-319-08867-9_4},
 doi = {10.1007/978-3-319-08867-9_4},
 acmid = {2735055},
}

@inproceedings{Trinh:APLAS:2013,
author="Trinh, Minh-Thai
and Le, Quang Loc
and David, Cristina
and Chin, Wei-Ngan",
title="Bi-Abduction with Pure Properties for Specification Inference",
bookTitle="Programming Languages and Systems: 11th Asian Symposium, APLAS 2013, Australia. Proceedings",
year="2013",
pages="107--123",
isbn="978-3-319-03542-0",
doi="10.1007/978-3-319-03542-0_8",
url="http://dx.doi.org/10.1007/978-3-319-03542-0_8"
}

@inproceedings{Calcagno:POPL:09,
  author    = {Cristiano Calcagno and
               Dino Distefano and
               Peter W. O'Hearn and
               Hongseok Yang},
  title     = {Compositional shape analysis by means of bi-abduction},
  booktitle = {POPL},
  year      = {2009},
  pages     = {289--300},
  url       = {http://doi.acm.org/10.1145/1480881.1480917},
  doi       = {10.1145/1480881.1480917},
  timestamp = {Tue, 14 Oct 2014 03:09:51 +0200},
  biburl    = {http://dblp.uni-trier.de/rec/bib/conf/popl/CalcagnoDOY09},
  bibsource = {dblp computer science bibliography, http://dblp.org}
}

@inproceedings{Dudka:CAV:2011,
 author = {Dudka, Kamil and Peringer, Petr and Vojnar, Tom\'{a}\v{s}},
 title = {Predator: A Practical Tool for Checking Manipulation of Dynamic Data Structures Using Separation Logic},
 booktitle = {CAV},
 series = {CAV'11},
 year = {2011},
 isbn = {978-3-642-22109-5},
 location = {Snowbird, UT},
 pages = {372--378},
 numpages = {7},
 url = {http://dl.acm.org/citation.cfm?id=2032305.2032334},
 acmid = {2032334},
 publisher = {Springer-Verlag},
 address = {Berlin, Heidelberg},
}

@InProceedings{Loc:TACAS:2018,
author="Le, Quang Loc
and Sun, Jun
and Qin, Shengchao",
editor="Beyer, Dirk
and Huisman, Marieke",
title="Frame Inference for Inductive Entailment Proofs in Separation Logic",
booktitle="Tools and Algorithms for the Construction and Analysis of Systems",
year="2018",
pages="41--60",
abstract="Given separation logic formulae {\$}{\$}A{\$}{\$}Aand {\$}{\$}C{\$}{\$}C, frame inference is the problem of checking whether {\$}{\$}A{\$}{\$}Aentails {\$}{\$}C{\$}{\$}Cand simultaneously inferring residual heaps. Existing approaches on frame inference do not support inductive proofs with general inductive predicates. In this work, we present an automatic frame inference approach for an expressive fragment of separation logic. We further show how to strengthen the inferred frame through predicate normalization and arithmetic inference. We have integrated our approach into an existing verification system. The experimental results show that our approach helps to establish a number of non-trivial inductive proofs which are beyond the capability of all existing tools.",
isbn="978-3-319-89960-2"
}


@inproceedings{Berdine:CAV11,
 author = {Berdine, Josh and Cook, Byron and Ishtiaq, Samin},
 title = {SLAYER: memory safety for systems-level code},
 booktitle = {CAV'11},
 year = {2011},
 isbn = {978-3-642-22109-5},
 location = {Snowbird, UT},
 pages = {178--183},
 numpages = {6},
 url = {http://dl.acm.org/citation.cfm?id=2032305.2032320},
 acmid = {2032320},
 publisher = {Springer-Verlag},
 address = {Berlin, Heidelberg},
}

@InProceedings{ POPL08:Chang,
	author = "B.-Y. E. Chang and X. Rival",
	title = "Relational inductive shape analysis",
	booktitle = POPL,
	year = "2008",
	pages = "247--260"
}

@inproceedings{Magill:POPL10,
 author = {Magill, Stephen and Tsai, Ming-Hsien and Lee, Peter and Tsay, Yih-Kuen},
 title = {Automatic numeric abstractions for heap-manipulating programs},
 booktitle = {POPL '10},
 series = {POPL '10},
 year = {2010},
 isbn = {978-1-60558-479-9},
 location = {Madrid, Spain},
 pages = {211--222},
 numpages = {12},
 publisher = {ACM},
 address = {New York, NY, USA},
 keywords = {abstraction, program verification, separation logic, shape analysis, termination}
}

@inproceedings{Remy:POPL:1997,
  author    = {Didier R{\'{e}}my and
               Jerome Vouillon},
  title     = {Objective {ML:} {A} Simple Object-Oriented Extension of {ML}},
  booktitle = {Conference Record of POPL'97: The 24th {ACM} {SIGPLAN-SIGACT} Symposium
               on Principles of Programming Languages, Papers Presented at the Symposium,
               Paris, France, 15-17 January 1997},
  pages     = {40--53},
  year      = {1997},
  url       = {https://doi.org/10.1145/263699.263707},
  doi       = {10.1145/263699.263707},
  timestamp = {Tue, 06 Nov 2018 11:07:43 +0100},
  biburl    = {https://dblp.org/rec/bib/conf/popl/RemyV97},
  bibsource = {dblp computer science bibliography, https://dblp.org}
}

@InProceedings{ Popeea:ASIAN06,
	author = "C. Popeea and W.-N. Chin",
	title = "Inferring Disjunctive Postconditions",
	booktitle = "ASIAN",
	year = "2006",
	pages = "331--345",
	ee = "http://dx.doi.org/10.1007/978-3-540-77505-8\_26",
	bibsource = "DBLP, http://dblp.uni-trier.de"
}

@inproceedings{Pham:CAV2011,
  author    = {Tuan-Hung Pham and
               Minh-Thai Trinh and
               Anh-Hoang Truong and
               Wei-Ngan Chin},
  title     = {FixBag: A Fixpoint Calculator for Quantified Bag Constraints},
  booktitle = {CAV},
  year      = {2011},
  pages     = {656-662},
  ee        = {http://dx.doi.org/10.1007/978-3-642-22110-1_53},
  bibsource = {DBLP, http://dblp.uni-trier.de}
}

@InProceedings{ Popeea:PEPM08,
	author = "Corneliu Popeea and Dana N. Xu and Wei-Ngan Chin",
	title = "A practical and precise inference and specializer for array bound checks elimination",
	booktitle = "PEPM",
	year = "2008",
	pages = "177--187",
	ee = "http://doi.acm.org/10.1145/1328408.1328434",
	bibsource = "DBLP, http://dblp.uni-trier.de"
}

@inproceedings{Pugh:SC:1991,
  author    = {William Pugh},
  title     = {The Omega test: a fast and practical integer programming algorithm
               for dependence analysis},
  booktitle = {Proceedings Supercomputing '91, Albuquerque, NM, USA, November 18-22,
               1991},
  pages     = {4--13},
  year      = {1991},
  url       = {https://doi.org/10.1145/125826.125848},
  doi       = {10.1145/125826.125848},
  timestamp = {Sun, 02 Jun 2019 21:17:15 +0200},
  biburl    = {https://dblp.org/rec/bib/conf/sc/Pught91},
  bibsource = {dblp computer science bibliography, https://dblp.org}
}

@inproceedings{Moura:TACAS:2008,
  author    = {Leonardo Mendon{\c{c}}a de Moura and
               Nikolaj Bj{\o}rner},
  title     = {{Z3:} An Efficient {SMT} Solver},
  booktitle = {Tools and Algorithms for the Construction and Analysis of Systems,
               14th International Conference, {TACAS} 2008, Held as Part of the Joint
               European Conferences on Theory and Practice of Software, {ETAPS} 2008,
               Budapest, Hungary, March 29-April 6, 2008. Proceedings},
  pages     = {337--340},
  year      = {2008},
  url       = {https://doi.org/10.1007/978-3-540-78800-3\_24},
  doi       = {10.1007/978-3-540-78800-3\_24},
  timestamp = {Tue, 14 May 2019 10:00:53 +0200},
  biburl    = {https://dblp.org/rec/bib/conf/tacas/MouraB08},
  bibsource = {dblp computer science bibliography, https://dblp.org}
}

@inproceedings{Elgaard:CAV:1998,
  author    = {Jacob Elgaard and
               Nils Klarlund and
               Anders M{\o}ller},
  title     = {{MONA} 1.x: New Techniques for {WS1S} and {WS2S}},
  booktitle = {Computer Aided Verification, 10th International Conference, {CAV}
               '98, Vancouver, BC, Canada, June 28 - July 2, 1998, Proceedings},
  pages     = {516--520},
  year      = {1998},
  url       = {https://doi.org/10.1007/BFb0028773},
  doi       = {10.1007/BFb0028773},
  timestamp = {Tue, 14 May 2019 10:00:43 +0200},
  biburl    = {https://dblp.org/rec/bib/conf/cav/ElgaardKM98},
  bibsource = {dblp computer science bibliography, https://dblp.org}
}

@book{Nipkow:Springer:2002,
  author    = {Tobias Nipkow and
               Lawrence C. Paulson and
               Markus Wenzel},
  title     = {Isabelle/HOL - {A} Proof Assistant for Higher-Order Logic},
  series    = {Lecture Notes in Computer Science},
  volume    = {2283},
  publisher = {Springer},
  year      = {2002},
  url       = {https://doi.org/10.1007/3-540-45949-9},
  doi       = {10.1007/3-540-45949-9},
  isbn      = {3-540-43376-7},
  timestamp = {Tue, 14 May 2019 10:00:35 +0200},
  biburl    = {https://dblp.org/rec/bib/books/sp/NipkowPW02},
  bibsource = {dblp computer science bibliography, https://dblp.org}
}

@inproceedings{Nguyen:CAV:2008,
  author    = {Huu Hai Nguyen and
               Wei{-}Ngan Chin},
  title     = {Enhancing Program Verification with Lemmas},
  booktitle = {Computer Aided Verification, 20th International Conference, {CAV}
               2008, Princeton, NJ, USA, July 7-14, 2008, Proceedings},
  pages     = {355--369},
  year      = {2008},
  url       = {https://doi.org/10.1007/978-3-540-70545-1\_34},
  doi       = {10.1007/978-3-540-70545-1\_34},
  timestamp = {Tue, 14 May 2019 10:00:43 +0200},
  biburl    = {https://dblp.org/rec/bib/conf/cav/NguyenC08},
  bibsource = {dblp computer science bibliography, https://dblp.org}
}

@article{chin2012automated,
  title={Automated verification of shape, size and bag properties via user-defined predicates in separation logic},
  author={Chin, Wei-Ngan and David, Cristina and Nguyen, Huu Hai and Qin, Shengchao},
  journal={Science of Computer Programming},
  volume={77},
  number={9},
  pages={1006--1036},
  year={2012},
  publisher={Elsevier}
}

@inproceedings{reynolds2002separation,
  title={Separation logic: A logic for shared mutable data structures},
  author={Reynolds, John C},
  booktitle={Proceedings 17th Annual IEEE Symposium on Logic in Computer Science},
  pages={55--74},
  year={2002},
  organization={IEEE}
}

@article{ishtiaq2001bi,
  title={BI as an assertion language for mutable data structures},
  author={Ishtiaq, Samin S and O'hearn, Peter W},
  journal={ACM SIGPLAN Notices},
  volume={36},
  number={3},
  pages={14--26},
  year={2001},
  publisher={ACM}
}

@article{hoare1969axiomatic,
  title={An axiomatic basis for computer programming},
  author={Hoare, Charles Antony Richard},
  journal={Communications of the ACM},
  volume={12},
  number={10},
  pages={576--580},
  year={1969},
  publisher={ACM}
}

@incollection{floyd1993assigning,
  title={Assigning meanings to programs},
  author={Floyd, Robert W},
  booktitle={Program Verification},
  pages={65--81},
  year={1993},
  publisher={Springer}
}

@inproceedings{chin2007multiple,
  title={Multiple pre/post specifications for heap-manipulating methods},
  author={Chin, Wei-Ngan and David, Cristina and Nguyen, Huu Hai and Qin, Shengchao},
  booktitle={10th IEEE High Assurance Systems Engineering Symposium (HASE'07)},
  pages={357--364},
  year={2007},
  organization={IEEE}
}

@article{david2011immutable,
  title={Immutable specifications for more concise and precise verification},
  author={David, Cristina and Chin, Wei-Ngan},
  journal={ACM SIGPLAN Notices},
  volume={46},
  number={10},
  pages={359--374},
  year={2011},
  publisher={ACM}
}

@inproceedings{costea2014hipimm,
  title={Hipimm: verifying granular immutability guarantees},
  author={Costea, Andreea and Sharma, Asankhaya and David, Cristina},
  booktitle={Proceedings of the ACM SIGPLAN 2014 Workshop on Partial Evaluation and Program Manipulation},
  pages={189--193},
  year={2014},
  organization={ACM}
}

@inproceedings{gherghina2011structured,
  title={Structured specifications for better verification of heap-manipulating programs},
  author={Gherghina, Cristian and David, Cristina and Qin, Shengchao and Chin, Wei-Ngan},
  booktitle={International Symposium on Formal Methods},
  pages={386--401},
  year={2011},
  organization={Springer}
}

@inproceedings{sharma2015certified,
  title={Certified reasoning with infinity},
  author={Sharma, Asankhaya and Wang, Shengyi and Costea, Andreea and Hobor, Aquinas and Chin, Wei-Ngan},
  booktitle={International Symposium on Formal Methods},
  pages={496--513},
  year={2015},
  organization={Springer}
}

@inproceedings{nguyen2007automated,
  title={Automated verification of shape and size properties via separation logic},
  author={Nguyen, Huu Hai and David, Cristina and Qin, Shengchao and Chin, Wei-Ngan},
  booktitle={International Workshop on Verification, Model Checking, and Abstract Interpretation},
  pages={251--266},
  year={2007},
  organization={Springer}
}

@inproceedings{LeGHC:ICFEM14,
  author    = {Ton Chanh Le and
  Cristian Gherghina and
  Aquinas Hobor and
  Wei{-}Ngan Chin},
  title     = {A Resource-Based Logic for Termination and Non-termination Proofs},
  booktitle = {Formal Methods and Software Engineering - 16th International Conference
  on Formal Engineering Methods, {ICFEM} 2014, Luxembourg, Luxembourg,
  November 3-5, 2014. Proceedings},
  pages     = {267--283},
  year      = {2014},
  url       = {https://doi.org/10.1007/978-3-319-11737-9\_18},
  doi       = {10.1007/978-3-319-11737-9\_18},
  timestamp = {Tue, 14 May 2019 10:00:50 +0200},
  biburl    = {https://dblp.org/rec/bib/conf/icfem/LeGHC14},
  bibsource = {dblp computer science bibliography, https://dblp.org}
}

@inproceedings{LeQC:PLDI15,
  author    = {Ton Chanh Le and
  Shengchao Qin and
  Wei{-}Ngan Chin},
  title     = {Termination and non-termination specification inference},
  booktitle = {Proceedings of the 36th {ACM} {SIGPLAN} Conference on Programming
  Language Design and Implementation, Portland, OR, USA, June 15-17,
  2015},
  pages     = {489--498},
  year      = {2015},
  url       = {https://doi.org/10.1145/2737924.2737993},
  doi       = {10.1145/2737924.2737993},
  timestamp = {Tue, 06 Nov 2018 16:59:30 +0100},
  biburl    = {https://dblp.org/rec/bib/conf/pldi/LeQC15},
  bibsource = {dblp computer science bibliography, https://dblp.org}
}

@inproceedings{LeTC:TACAS17,
  author    = {Ton Chanh Le and
  Quang{-}Trung Ta and
  Wei{-}Ngan Chin},
  title     = {HipTNT+: {A} Termination and Non-termination Analyzer by Second-Order
  Abduction - (Competition Contribution)},
  booktitle = {Tools and Algorithms for the Construction and Analysis of Systems
  - 23rd International Conference, {TACAS} 2017, Held as Part of the
  European Joint Conferences on Theory and Practice of Software, {ETAPS}
  2017, Uppsala, Sweden, April 22-29, 2017, Proceedings, Part {II}},
  pages     = {370--374},
  year      = {2017},
  url       = {https://doi.org/10.1007/978-3-662-54580-5\_25},
  doi       = {10.1007/978-3-662-54580-5\_25},
  timestamp = {Tue, 14 May 2019 10:00:53 +0200},
  biburl    = {https://dblp.org/rec/bib/conf/tacas/LeTC17},
  bibsource = {dblp computer science bibliography, https://dblp.org}
}

@inproceedings{MollerS01,
  author    = {Anders M{\o}ller and
               Michael I. Schwartzbach},
  title     = {The Pointer Assertion Logic Engine},
  booktitle = {Proceedings of the 2001 {ACM} {SIGPLAN} Conference on Programming
               Language Design and Implementation (PLDI), Snowbird, Utah, USA, June
               20-22, 2001},
  pages     = {221--231},
  year      = {2001}
}

@inproceedings{KlarlundS93,
  author    = {Nils Klarlund and
               Michael I. Schwartzbach},
  title     = {Graph Types},
  booktitle = {Conference Record of the Twentieth Annual {ACM} {SIGPLAN-SIGACT} Symposium
               on Principles of Programming Languages, Charleston, South Carolina,
               USA, January 1993},
  pages     = {196--205},
  year      = {1993}
}

@inproceedings{HenriksenJJKPRS95,
  author    = {Jesper G. Henriksen and
               Jakob L. Jensen and
               Michael E. J{\o}rgensen and
               Nils Klarlund and
               Robert Paige and
               Theis Rauhe and
               Anders Sandholm},
  title     = {Mona: Monadic Second-Order Logic in Practice},
  booktitle = {Tools and Algorithms for Construction and Analysis of Systems, First
               International Workshop, {TACAS} '95, Aarhus, Denmark, May 19-20, 1995,
               Proceedings},
  pages     = {89--110},
  year      = {1995}
}

@inproceedings{HarwoodCW08,
  author    = {Will Harwood and
               Ana Cavalcanti and
               Jim Woodcock},
  title     = {A Theory of Pointers for the {UTP}},
  booktitle = {Theoretical Aspects of Computing - {ICTAC} 2008, 5th International
               Colloquium, Istanbul, Turkey, September 1-3, 2008. Proceedings},
  pages     = {141--155},
  year      = {2008}
}

@inproceedings{Leino10,
  author    = {K. Rustan M. Leino},
  title     = {Dafny: An Automatic Program Verifier for Functional Correctness},
  booktitle = {Logic for Programming, Artificial Intelligence, and Reasoning - 16th
               International Conference, LPAR-16, Dakar, Senegal, April 25-May 1,
               2010, Revised Selected Papers},
  pages     = {348--370},
  year      = {2010}
}

@inproceedings{SagivRW99,
  author    = {Shmuel Sagiv and
               Thomas W. Reps and
               Reinhard Wilhelm},
  title     = {Parametric Shape Analysis via 3-Valued Logic},
  booktitle = {{POPL} '99, Proceedings of the 26th {ACM} {SIGPLAN-SIGACT}
                  Symposium on Principles of Programming Languages, San Antonio,
                  TX, USA, January 20-22, 1999},
  pages     = {105--118},
  year      = {1999}
}

@inproceedings{Rugina04,
  author    = {Radu Rugina},
  title     = {Quantitative Shape Analysis},
  booktitle = {Static Analysis, 11th International Symposium, {SAS} 2004,
                  Verona, Italy, August 26-28, 2004, Proceedings},
  pages     = {228--245},
  year      = 2004
}

@inproceedings{HughesPS96,
  author    = {John Hughes and
               Lars Pareto and
               Amr Sabry},
  title     = {Proving the Correctness of Reactive Systems Using Sized Types},
  booktitle = {Conference Record of POPL'96: The 23rd {ACM} {SIGPLAN-SIGACT}
                  Symposium on Principles of Programming Languages, Papers
                  Presented at the Symposium, St. Petersburg Beach, Florida,
                  USA, January 21-24, 1996},
  pages     = {410--423},
  year      = {1996}
}

@inproceedings{XiP99,
  author    = {Hongwei Xi and
               Frank Pfenning},
  title     = {Dependent Types in Practical Programming},
  booktitle = {{POPL} '99, Proceedings of the 26th {ACM} {SIGPLAN-SIGACT}
                  Symposium on Principles of Programming Languages, San Antonio,
                  TX, USA, January 20-22, 1999},
  pages     = {214--227},
  year      = {1999}
}

@inproceedings{ChinK00,
  author    = {Wei{-}Ngan Chin and
               Siau{-}Cheng Khoo},
  title     = {Calculating Sized Types},
  booktitle = {Proceedings of the 2000 {ACM} {SIGPLAN} Workshop on Partial
                  Evaluation and Semantics-Based Program Manipulation {(PEPM}
                  '00), Boston, Massachusetts, USA, January 22-23, 2000},
  pages     = {62--72},
  year      = {2000}
}

@inproceedings{ChinKQPN05,
  author    = {Wei{-}Ngan Chin and
               Siau{-}Cheng Khoo and
               Shengchao Qin and
               Corneliu Popeea and
               Huu Hai Nguyen},
  title     = {Verifying safety policies with size properties and alias
                  controls},
  booktitle = {27th International Conference on Software Engineering {(ICSE}
                  2005), 15-21 May 2005, St. Louis, Missouri, {USA}},
  pages     = {186--195},
  year      = {2005}
}

@inproceedings{ChenX05,
  author    = {Chiyan Chen and
               Hongwei Xi},
  title     = {Combining programming with theorem proving},
  booktitle = {Proceedings of the 10th {ACM} {SIGPLAN} International Conference on
               Functional Programming, {ICFP} 2005, Tallinn, Estonia, September 26-28,
               2005},
  pages     = {66--77},
  year      = {2005}
}

@inproceedings{KuncakNR05,
  author    = {Viktor Kuncak and
               Huu Hai Nguyen and
               Martin C. Rinard},
  title     = {An Algorithm for Deciding {BAPA:} Boolean Algebra with Presburger
                  Arithmetic},
  booktitle = {Automated Deduction - CADE-20, 20th International Conference on
                  Automated Deduction, Tallinn, Estonia, July 22-27, 2005,
                  Proceedings},
  pages     = {260--277},
  year      = {2005}
}

@inproceedings{LahiriQ06,
  author    = {Shuvendu K. Lahiri and
               Shaz Qadeer},
  title     = {Verifying properties of well-founded linked lists},
  booktitle = {Proceedings of the 33rd {ACM} {SIGPLAN-SIGACT} Symposium on
                  Principles of Programming Languages, {POPL} 2006, Charleston,
                  South Carolina, USA, January 11-13, 2006},
  pages     = {115--126},
  year      = {2006}
}

@article{BurstallD77,
  author    = {Rod M. Burstall and
               John Darlington},
  title     = {A Transformation System for Developing Recursive Programs},
  journal   = {J. {ACM}},
  volume    = {24},
  number    = {1},
  pages     = {44--67},
  year      = {1977}
}

@inproceedings{WalkerM00,
  author    = {David Walker and
               J. Gregory Morrisett},
  title     = {Alias Types for Recursive Data Structures},
  booktitle = {Types in Compilation, Third International Workshop, {TIC} 2000,
                  Montreal, Canada, September 21, 2000, Revised Selected Papers},
  pages     = {177--206},
  year      = {2000}
}

@inproceedings{BerdineCO05,
  author    = {Josh Berdine and
               Cristiano Calcagno and
               Peter W. O'Hearn},
  title     = {Symbolic Execution with Separation Logic},
  booktitle = {Programming Languages and Systems, Third Asian Symposium, {APLAS}
                  2005, Tsukuba, Japan, November 2-5, 2005, Proceedings},
  pages     = {52--68},
  year      = {2005}
}


@inproceedings{FlanaganLLNSS02,
  author    = {Cormac Flanagan and
               K. Rustan M. Leino and
               Mark Lillibridge and
               Greg Nelson and
               James B. Saxe and
               Raymie Stata},
  title     = {Extended Static Checking for Java},
  booktitle = {Proceedings of the 2002 {ACM} {SIGPLAN} Conference on Programming
                  Language Design and Implementation (PLDI), Berlin, Germany,
                  June 17-19, 2002},
  pages     = {234--245},
  year      = {2002}
}

@inproceedings{CokK04,
  author    = {David R. Cok and
               Joseph Kiniry},
  title     = {ESC/Java2: Uniting ESC/Java and {JML}},
  booktitle = {Construction and Analysis of Safe, Secure, and Interoperable
                  Smart Devices, International Workshop, {CASSIS} 2004,
                  Marseille, France, March 10-14, 2004, Revised Selected Papers},
  pages     = {108--128},
  year      = {2004}
}

@article{LeavensBR06,
  author    = {Gary T. Leavens and
               Albert L. Baker and
               Clyde Ruby},
  title     = {Preliminary design of {JML:} a behavioral interface specification
                  language for java},
  journal   = {{ACM} {SIGSOFT} Software Engineering Notes},
  volume    = {31},
  number    = {3},
  pages     = {1--38},
  year      = {2006}
}

@article{Cok05,
  author    = {David R. Cok},
  title     = {Reasoning with specifications containing method calls and model
                  fields},
  journal   = {Journal of Object Technology},
  volume    = {4},
  number    = {8},
  pages     = {77--103},
  year      = {2005}
}

@article{DetlefsNS05,
  author    = {David Detlefs and
               Greg Nelson and
               James B. Saxe},
  title     = {Simplify: a theorem prover for program checking},
  journal   = {J. {ACM}},
  volume    = {52},
  number    = {3},
  pages     = {365--473},
  year      = {2005}
}

@inproceedings{BarnettLS05,
  author    = {Mike Barnett and Rustan Leino and Wolfram Schulte},
  title     = {The Spec\# Programming System: An Overview},
  booktitle = {CASSIS 2004, Construction and Analysis of Safe, Secure and
                  Interoperable Smart devices},
  pages     = {49--69},
  year      = {2005}
}

@article{KuncakLZR06,
  author    = {Viktor Kuncak and
               Patrick Lam and
               Karen Zee and
               Martin C. Rinard},
  title     = {Modular Pluggable Analyses for Data Structure Consistency},
  journal   = {{IEEE} Trans. Software Eng.},
  volume    = {32},
  number    = {12},
  pages     = {988--1005},
  year      = {2006}
}

@Book{NipkowPW02,
  author	= {Tobias Nipkow and Lawrence C. Paulson and Markus Wenzel},
  title		= {Isabelle/HOL --- A Proof Assistant for Higher-Order Logic},
  publisher	= {Springer},
  series	= {LNCS},
  volume	= 2283,
  year		= 2002}
}

@phdthesis{Lam07,
  author    = {Patrick Lam},
  title     = {The Hob system for verifying software design properties},
  school    = {Massachusetts Institute of Technology, Cambridge, MA, {USA}},
  year      = {2007}
}

@mastersthesis{Tschannen09,
  author    = {Julian Tschannen},
  title     = {Automatic Verification of Eiffel Programs},
  school    = {ETH Zurich},
  year      = {2007}
}

@inproceedings{PiskacWZ13,
  author    = {Ruzica Piskac and
               Thomas Wies and
               Damien Zufferey},
  title     = {{Automating Separation Logic Using {SMT}}},
  booktitle = CAV,
  pages     = {773--789},
  year      = {2013}
}

@inproceedings{PiskacWZ14,
  author    = {Ruzica Piskac and
               Thomas Wies and
               Damien Zufferey},
  title     = {{Automating Separation Logic with Trees and Data}},
  booktitle = CAV,
  pages     = {711--728},
  year      = 2014,
  timestamp = {Mon, 30 Jun 2014 11:31:20 +0200}
}

@inproceedings{MouraB08,
  author    = {Leonardo Mendon{\c{c}}a De Moura and
               Nikolaj Bj{\o}rner},
  title     = {{{Z3:} An Efficient {SMT} Solver}},
  booktitle = TACAS,
  pages     = {337--340},
  year      = {2008}
}

@article{BozgaIP10,
  author    = {Marius Bozga and
               Radu Iosif and
               Swann Perarnau},
  title     = {{Quantitative Separation Logic and Programs with Lists}},
  journal   = {J. Autom. Reasoning},
  volume    = {45},
  number    = {2},
  pages     = {131--156},
  year      = {2010}
}

@inproceedings{PerezR11,
  author    = {Juan Antonio Navarro P{\'{e}}rez and
               Andrey Rybalchenko},
  title     = {{Separation Logic + Superposition Calculus = Heap Theorem Prover}},
  booktitle = PLDI,
  pages     = {556--566},
  year      = {2011},
  timestamp = {Tue, 07 Jun 2011 16:07:38 +0200}
}


@inproceedings{PerezR13,
  author    = {Juan Antonio Navarro P{\'{e}}rez and
               Andrey Rybalchenko},
  title     = {{Separation Logic Modulo Theories}},
  booktitle = APLAS,
  pages     = {90--106},
  year      = {2013},
  timestamp = {Fri, 27 Dec 2013 18:39:58 +0100}
}

@inproceedings{EneaLSV14,
  author    = {Constantin Enea and
               Ondrej Leng{\'{a}}l and
               Mihaela Sighireanu and
               Tom{\'{a}}s Vojnar},
  title     = {{Compositional Entailment Checking for a Fragment of Separation Logic}},
  booktitle = APLAS,
  pages     = {314--333},
  year      = {2014},
  timestamp = {Wed, 15 Oct 2014 15:39:11 +0200}
}

@inproceedings{IosifRS13,
  author    = {Radu Iosif and
               Adam Rogalewicz and
               Jiri Sim{\'{a}}cek},
  title     = {{The Tree Width of Separation Logic with Recursive Definitions}},
  booktitle = CADE,
  pages     = {21--38},
  year      = {2013},
  timestamp = {Sat, 15 Jun 2013 19:33:15 +0200}
}

@inproceedings{IosifRV14,
  author    = {Radu Iosif and
               Adam Rogalewicz and
               Tom{\'{a}}s Vojnar},
  title     = {{Deciding Entailments in Inductive Separation Logic with Tree Automata}},
  booktitle = ATVA,
  pages     = {201--218},
  year      = {2014},
  timestamp = {Mon, 03 Nov 2014 14:32:36 +0100}
}

@inproceedings{BerdineCO04,
  author    = {Josh Berdine and
               Cristiano Calcagno and
               Peter W. O'Hearn},
  title     = {{A Decidable Fragment of Separation Logic}},
  booktitle = FSTTCS,
  pages     = {97--109},
  year      = {2004},
  timestamp = {Fri, 22 Nov 2013 12:57:23 +0100}
}

@inproceedings{TaLKC16,
  author    = {Quang{-}Trung Ta and
               Ton Chanh Le and
               Siau{-}Cheng Khoo and
               Wei{-}Ngan Chin},
  title     = {Automated Mutual Explicit Induction Proof in Separation Logic},
  booktitle = {{FM} 2016: Formal Methods - 21st International Symposium, Limassol,
               Cyprus, November 9-11, 2016, Proceedings},
  pages     = {659--676},
  year      = 2016,
}

@inproceedings{TaLKC18,
  author    = {Quang{-}Trung Ta and
               Ton Chanh Le and
               Siau{-}Cheng Khoo and
               Wei{-}Ngan Chin},
  title     = {{Automated Lemma Synthesis in Symbolic-Heap Separation Logic}},
  booktitle = POPL,
  pages     = {9:1--9:29},
  year      = {2018}
}

@article{TaLKC19,
  author    = {Quang{-}Trung Ta and
               Ton Chanh Le and
               Siau{-}Cheng Khoo and
               Wei{-}Ngan Chin},
  title     = {Automated mutual induction proof in separation logic},
  journal   = {Formal Aspect of Computing},
  volume    = {31},
  number    = {2},
  pages     = {207--230},
  year      = {2019}
}

@inproceedings{PekQM14,
  author    = {Edgar Pek and
               Xiaokang Qiu and
               P. Madhusudan},
  title     = {{Natural proofs for data structure manipulation in {C} using
                Separation Logic}},
  booktitle = PLDI,
  pages     = {46},
  year      = {2014}
}

@inproceedings{QiuGSM13,
  author    = {Xiaokang Qiu and
               Pranav Garg and
               Andrei Stefanescu and
               Parthasarathy Madhusudan},
  title     = {{Natural proofs for structure, data, and separation}},
  booktitle = PLDI,
  pages     = {231--242},
  year      = {2013}
}

@inproceedings{EneaSW15,
  author    = {Constantin Enea and
               Mihaela Sighireanu and
               Zhilin Wu},
  title     = {On Automated Lemma Generation for Separation Logic with Inductive
               Definitions},
  booktitle = ATVA,
  pages     = {80--96},
  year      = {2015}
}

@inproceedings{ChuJT15,
  author    = {Duc-Hiep Chu and
               Joxan Jaffar and
               Minh-Thai Trinh},
  title     = {{Automatic induction proofs of data-structures in imperative programs}},
  booktitle = PLDI,
  pages     = {457--466},
  year      = {2015}
}

@inproceedings{BrotherstonDP11,
  author    = {James Brotherston and
               Dino Distefano and
               Rasmus Lerchedahl Petersen},
  title     = {{Automated Cyclic Entailment Proofs in Separation Logic}},
  booktitle = CADE,
  pages     = {131--146},
  year      = {2011}
}

@inproceedings{LeCT15,
  author    = {Duy{-}Khanh Le and
               Wei{-}Ngan Chin and
               Yong Meng Teo},
  title     = {Threads as Resource for Concurrency Verification},
  booktitle = {Proceedings of the 2015 Workshop on Partial Evaluation and Program
               Manipulation, PEPM, Mumbai, India, January 15-17, 2015},
  pages     = {73--84},
  year      = {2015}
}

@inproceedings{LeCT12,
  author    = {Duy{-}Khanh Le and
               Wei{-}Ngan Chin and
               Yong Meng Teo},
  title     = {Variable Permissions for Concurrency Verification},
  booktitle = {Formal Methods and Software Engineering - 14th International
                  Conference on Formal Engineering Methods, {ICFEM} 2012, Kyoto,
                  Japan, November 12-16, 2012. Proceedings},
  pages     = {5--21},
  year      = {2012}
}

@inproceedings{LeCT13deadlock,
  author    = {Duy{-}Khanh Le and
               Wei{-}Ngan Chin and
               Yong Meng Teo},
  title     = {An Expressive Framework for Verifying Deadlock Freedom},
  booktitle = {Automated Technology for Verification and Analysis - 11th
                  International Symposium, {ATVA} 2013, Hanoi, Vietnam, October
                  15-18, 2013. Proceedings},
  pages     = {287--302},
  year      = {2013}
}

@inproceedings{LeCT13barrier,
  author    = {Duy{-}Khanh Le and
               Wei{-}Ngan Chin and
               Yong Meng Teo},
  title     = {Verification of Static and Dynamic Barrier Synchronization Using
                  Bounded Permissions},
  booktitle = {Formal Methods and Software Engineering - 15th International
                  Conference on Formal Engineering Methods, {ICFEM} 2013,
                  Queenstown, New Zealand, October 29 - November 1, 2013,
                  Proceedings},
  pages     = {231--248},
  year      = {2013}
}

@inproceedings{CosteaCQC18,
  author    = {Andreea Costea and
               Wei{-}Ngan Chin and
               Shengchao Qin and
               Florin Craciun},
  title     = {Automated Modular Verification for Relaxed Communication Protocols},
  booktitle = {Programming Languages and Systems - 16th Asian Symposium, {APLAS}
               2018, Wellington, New Zealand, December 2-6, 2018, Proceedings},
  pages     = {284--305},
  year      = {2018}
}

@inproceedings{CraciunKC15,
  author    = {Florin Craciun and
               Tibor Kiss and
               Andreea Costea},
  title     = {Towards a Session Logic for Communication Protocols},
  booktitle = {20th International Conference on Engineering of Complex Computer
                  Systems, {ICECCS} 2015, Gold Coast, Australia, December 9-12,
                  2015},
  pages     = {140--149},
  year      = {2015}
}

@inproceedings{ChinDNQ08,
  author    = {Wei{-}Ngan Chin and
               Cristina David and
               Huu Hai Nguyen and
               Shengchao Qin},
  title     = {Enhancing modular {OO} verification with separation logic},
  booktitle = {Proceedings of the 35th {ACM} {SIGPLAN-SIGACT} Symposium on
                  Principles of Programming Languages, {POPL} 2008, San
                  Francisco, California, USA, January 7-12, 2008},
  pages     = {87--99},
  year      = {2008}
}

@InProceedings{khanh2012,
author="Le, Duy-Khanh
and Chin, Wei-Ngan
and Teo, Yong-Meng",
editor="Aoki, Toshiaki
and Taguchi, Kenji",
title="Variable Permissions for Concurrency Verification",
booktitle="Formal Methods and Software Engineering",
year="2012",
publisher="Springer Berlin Heidelberg",
address="Berlin, Heidelberg",
pages="5--21",
isbn="978-3-642-34281-3"
}

@InProceedings{khanh2013,
author="Le, Duy-Khanh
and Chin, Wei-Ngan
and Teo, Yong-Meng",
editor="Van Hung, Dang
and Ogawa, Mizuhito",
title="An Expressive Framework for Verifying Deadlock Freedom",
booktitle="Automated Technology for Verification and Analysis",
year="2013",
publisher="Springer International Publishing",
address="Cham",
pages="287--302",
isbn="978-3-319-02444-8"
}

@InProceedings{khanh2013b,
author="Le, Duy-Khanh
and Chin, Wei-Ngan
and Teo, Yong-Meng",
editor="Groves, Lindsay
and Sun, Jing",
title="Verification of Static and Dynamic Barrier Synchronization Using Bounded Permissions",
booktitle="Formal Methods and Software Engineering",
year="2013",
publisher="Springer Berlin Heidelberg",
address="Berlin, Heidelberg",
pages="231--248",
isbn="978-3-642-41202-8"
}

@inproceedings{khanh2015,
author = {Le, Duy-Khanh and Chin, Wei-Ngan and Teo, Yong Meng},
title = {Threads as Resource for Concurrency Verification},
year = {2015},
isbn = {9781450332972},
publisher = {Association for Computing Machinery},
address = {New York, NY, USA},
url = {https://doi.org/10.1145/2678015.2682540},
doi = {10.1145/2678015.2682540},
booktitle = {Proceedings of the 2015 Workshop on Partial Evaluation and Program Manipulation},
pages = {73–84},
numpages = {12},
keywords = {threads as resource, first-class threads, separation logic, concurrency verification},
location = {Mumbai, India},
series = {PEPM '15}
}

@InProceedings{sharma2015,
author="Sharma, Asankhaya
and Hobor, Aquinas
and Chin, Wei-Ngan",
editor="Butler, Michael
and Conchon, Sylvain
and Za{\"i}di, Fatiha",
title="Specifying Compatible Sharing in Data Structures",
booktitle="Formal Methods and Software Engineering",
year="2015",
publisher="Springer International Publishing",
address="Cham",
pages="349--365",
isbn="978-3-319-25423-4"
}

@INPROCEEDINGS{costea2015,
  author={Craciun, Florin and Kiss, Tibor and Costea, Andreea},
  booktitle={2015 20th International Conference on Engineering of Complex Computer Systems (ICECCS)}, 
  title={Towards a Session Logic for Communication Protocols}, 
  year={2015},
  volume={},
  number={},
  pages={140-149},
  doi={10.1109/ICECCS.2015.33}}

@InProceedings{costea2018,
author="Costea, Andreea
and Chin, Wei-Ngan
and Qin, Shengchao
and Craciun, Florin",
editor="Ryu, Sukyoung",
title="Automated Modular Verification for Relaxed Communication Protocols",
booktitle="Programming Languages and Systems",
year="2018",
publisher="Springer International Publishing",
address="Cham",
pages="284--305",
isbn="978-3-030-02768-1"
}


@phdthesis{costea2017,
	author = { Mirela-Andreea Costea},
	title = {A Session Logic for Relaxed Communication Protocols},
	year = {2017},
}


@InProceedings{Toan2019,
	author="Nguyen, Thanh-Toan
	and Ta, Quang-Trung
	and Chin, Wei-Ngan",
	editor="Enea, Constantin
	and Piskac, Ruzica",
	title="Automatic Program Repair Using Formal Verification and Expression Templates",
	booktitle="Verification, Model Checking, and Abstract Interpretation",
	year="2019",
	publisher="Springer International Publishing",
	address="Cham",
	pages="70--91",
	isbn="978-3-030-11245-5"
}

@InProceedings{Toan2021,
	author="Nguyen, Thanh-Toan
	and Ta, Quang-Trung
	and Sergey, Ilya
	and Chin, Wei-Ngan",
	editor="Henglein, Fritz
	and Shoham, Sharon
	and Vizel, Yakir",
	title="Automated Repair of Heap-Manipulating Programs Using Deductive Synthesis",
	booktitle="Verification, Model Checking, and Abstract Interpretation",
	year="2021",
	publisher="Springer International Publishing",
	address="Cham",
	pages="376--400",
    isbn="978-3-030-67067-2"
}


@misc{HIPgit,
	howpublished = "\url{https://github.com/hipsleek/hipsleek}"}

@misc{HIPonline,
	howpublished = "\url{http://loris-5.d2.comp.nus.edu.sg/TeachHIP/index.html}"}